;;;; -*- Mode: Lisp -*-
;;;; $Id: usocket-allegro.lisp 822 2010-09-24 10:24:44Z binghe $

(in-package :usocket)

(defun socket-connect/udp (host port &key element-type timeout deadline nodelay
			   local-host local-port)
  (declare (ignore timeout deadline nodelay element-type))
  (let ((socket))
    (setf socket
	  (with-mapped-conditions (socket)
	    (apply #'socket:make-socket
		   (nconc (list :type :datagram
				:address-family :internet
				:local-host (when local-host
					      (host-to-hostname local-host))
				:local-port local-port)
			  (if (and host port)
			      (list :connect :active
				    :remote-host (host-to-hostname host)
				    :remote-port port)
			      (list :connect :passive))))))
    (make-datagram-socket socket)))

(defmethod socket-send ((socket datagram-usocket) buffer length &key host port)
  (let ((s (socket socket)))
    (socket:send-to s buffer length :remote-host host :remote-port port)))

(defmethod socket-receive ((socket datagram-usocket) buffer length &key)
  (let ((s (socket socket)))
    (socket:receive-from s length :buffer buffer :extract t)))
